<?php
/*
Plugin Name: Extra shortcodes
Plugin URI: http://web-profile.com.ua/wordpress/plugins/extra-shortcodes/
Description: Extra shortcodes: [site_title], [site_desc], [site_url], [wp_version], [date format="d-M-Y"], [time], [year plus="2"], [month minus="3"], [day], [weekday]
Version: 1.0
Author: webvitaly
Author Email: webvitaly(at)gmail.com
Author URI: http://web-profile.com.ua/wordpress/

Future features:
- [hours am pm];
- [hours loop="1"];
- [minutes loop="1"];
- [seconds loop="1"];
- fix back loop [day minus="30" loop="1"];
- fix multi loop [month plus="24" loop="1"] (all with loop);
*/


if ( !function_exists('site_title_shortcode') ) {
	function site_title_shortcode( $atts ) {
		return get_bloginfo('name');
	}
	add_shortcode( 'site_title', 'site_title_shortcode' );
	add_shortcode( 'sitetitle', 'site_title_shortcode' ); // just in case
	//add_shortcode( 'site-title', 'site_title_shortcode' ); // not good (Shortcode names should be all lowercase and use all letters, but numbers and underscores (not dashes!) should work fine too.)
}

if ( !function_exists('site_desc_shortcode') ) {
	function site_desc_shortcode( $atts ) {
		return get_bloginfo('description');
	}
	add_shortcode( 'site_desc', 'site_desc_shortcode' );
	add_shortcode( 'sitedesc', 'site_desc_shortcode' ); // just in case
	add_shortcode( 'site_description', 'site_desc_shortcode' ); // just in case
	add_shortcode( 'sitedescription', 'site_desc_shortcode' ); // just in case
	//add_shortcode( 'site-desc', 'site_desc_shortcode' ); // not good (Shortcode names should be all lowercase and use all letters, but numbers and underscores (not dashes!) should work fine too.)
}

if ( !function_exists('site_url_shortcode') ) {
	function site_url_shortcode( $atts ) {
		return get_bloginfo('url');
	}
	add_shortcode( 'site_url', 'site_url_shortcode' );
	add_shortcode( 'siteurl', 'site_url_shortcode' ); // just in case
	//add_shortcode( 'site-url', 'site_url_shortcode' ); // not good (Shortcode names should be all lowercase and use all letters, but numbers and underscores (not dashes!) should work fine too.)
}

if ( !function_exists('wp_version_shortcode') ) {
	function wp_version_shortcode( $atts ) {
		return get_bloginfo('version');
	}
	add_shortcode( 'wp_version', 'wp_version_shortcode' );
	add_shortcode( 'wpversion', 'wp_version_shortcode' ); // just in case
	//add_shortcode( 'wp-version', 'wp_version_shortcode' ); // not good (Shortcode names should be all lowercase and use all letters, but numbers and underscores (not dashes!) should work fine too.)
}

if ( !function_exists('date_shortcode') ) {
	function date_shortcode( $atts ) {
		extract( shortcode_atts( array(
			'format' => 'Y-m-d'
		), $atts ) );
		return date( $format );
	}
	add_shortcode( 'date', 'date_shortcode' );
}

if ( !function_exists('time_shortcode') ) {
	function time_shortcode( $atts ) {
		extract( shortcode_atts( array(
			'format' => 'H:i:s'
		), $atts ) );
		return date( $format );
	}
	add_shortcode( 'time', 'time_shortcode' );
}

if ( !function_exists('year_shortcode') ) {
	function year_shortcode( $atts ) {
		extract( shortcode_atts( array(
			'plus' => 0,
			'minus' => 0
		), $atts ) );
		$year = date( 'Y' );
		$year = (int)$year + $plus - $minus;
		if( $year < 0 ){ $year = 0; }
		return $year;
	}
	add_shortcode( 'year', 'year_shortcode' );
}

if ( !function_exists('month_shortcode') ) {
	function month_shortcode( $atts ) {
		extract( shortcode_atts( array(
			'plus' => 0,
			'minus' => 0,
			'loop' => 0
		), $atts ) );
		$month = date( 'm' );
		$month = (int)$month + $plus - $minus;
		if( $loop == 0 ){
			if( $month < 1 ){ $month = 1; }
			if( $month > 12 ){ $month = 12; }
		}else{
			if( $month < 1 ){ $month += 12; }
			if( $month > 12 ){ $month -= 12; }
		}
		return $month;
	}
	add_shortcode( 'month', 'month_shortcode' );
}

if ( !function_exists('month_name_shortcode') ) {
	function month_name_shortcode( $atts ) {
		return date( 'F' );
	}
	add_shortcode( 'month_name', 'month_name_shortcode' );
	add_shortcode( 'monthname', 'month_name_shortcode' ); // just in case
	//add_shortcode( 'month-name', 'month_name_shortcode' ); // not good (Shortcode names should be all lowercase and use all letters, but numbers and underscores (not dashes!) should work fine too.)
}

if ( !function_exists('day_shortcode') ) {
	function day_shortcode( $atts ) {
		extract( shortcode_atts( array(
			'plus' => 0,
			'minus' => 0,
			'loop' => 0
		), $atts ) );
		$day = date( 'd' );
		$day_max = (int)date( 't' );
		$day = (int)$day + $plus - $minus;
		if( $loop == 0 ){
			if( $day < 1 ){ $day = 1; }
			if( $day > $day_max ){ $day = $day_max; }
		}else{
			if( $day < 1 ){ $day += $day_max; /* wrong, current month could have 30 days and prev month could have 31 */ }
			if( $day > 12 ){ $day -= $day_max; }
		}
		return $day;
	}
	add_shortcode( 'day', 'day_shortcode' );
}

if ( !function_exists('weekday_shortcode') ) {
	function weekday_shortcode( $atts ) {
		return date( 'l' );
	}
	add_shortcode( 'weekday', 'weekday_shortcode' );
	add_shortcode( 'week_day', 'weekday_shortcode' ); // just in case
	//add_shortcode( 'week-day', 'weekday_shortcode' ); // not good (Shortcode names should be all lowercase and use all letters, but numbers and underscores (not dashes!) should work fine too.)
}

if ( !function_exists('hours_shortcode') ) {
	function hours_shortcode( $atts ) {
		return date( 'H' );
	}
	add_shortcode( 'hours', 'hours_shortcode' );
	add_shortcode( 'hour', 'hours_shortcode' ); // just in case
}

if ( !function_exists('minutes_shortcode') ) {
	function minutes_shortcode( $atts ) {
		return date( 'i' );
	}
	add_shortcode( 'minutes', 'minutes_shortcode' );
	add_shortcode( 'minute', 'minutes_shortcode' ); // just in case
}

if ( !function_exists('seconds_shortcode') ) {
	function seconds_shortcode( $atts ) {
		return date( 's' );
	}
	add_shortcode( 'seconds', 'seconds_shortcode' );
	add_shortcode( 'second', 'seconds_shortcode' ); // just in case
}
